<?php
  /**
   * recurse direcory
   *
   * This function recurses into a given base directory
   * and calls the supplied function for each file and directory
   *
   * @param   array ref $data The results of the search are stored here
   * @param   string    $base Where to start the search
   * @param   callback  $func Callback (function name or arayy with object,method)
   * @param   string    $dir  Current directory beyond $base
   * @param   int       $lvl  Recursion Level
   * @author  Andreas Gohr <andi@splitbrain.org>
   * modified by Samuele Tognini <samuele@netsons.org>
   */
  function _search($base='data/pages')
  {
    $dirs   = array();
    $files  = array();
    $files_tmp=array();
    $dirs_tmp=array();

    //read in directories and files
    $dh = @opendir($base);
    if(!$dh) return array();
    while(($file = readdir($dh)) !== false){
		//skip hidden files and upper dirs
		if(preg_match('/^[\._]/',$file)) continue;
		if(is_dir($base.'/'.$file)){
			$tmp=_search($base.'/'.$file);
			foreach ($tmp as $t)
				$files[]=$t;
			continue;
		}
      $files[] = $base.'/'.$file;
    }
    closedir($dh);
	return $files;
  }

function cache_delete($fakt='fdsafas')
{
	$id=getID();
	$thisfilename=wikiFN($id);
	$thisfilename=substr($thisfilename,strpos($thisfilename,'pages'));
	$depends=array();
	$files=_search(DOKU_PLUGIN.'swp/pages');
	foreach ($files as $file)
	{
		$str=file_get_contents($file);
		if (stripos($str,$thisfilename) || stripos($str,$fakt))
		{
			$depends[]=$file;
		}
	}
	$point=0;
	foreach ($depends as $dep)
	{
		$tmpl=$dep;
		$tmpl=substr($tmpl,0,strlen($tmpl)-4);
		$tmpl=substr($tmpl,stripos($tmpl,"swp/pages/")+10);
		$tmpl=str_replace("/",":",$tmpl);
		//$cordir=substr($cordir,1);
		$tmpmd=md5(wikiFN($tmpl).$_SERVER['HTTP_HOST'].$_SERVER['SERVER_PORT']);
		$path='data/cache/'.$tmpmd{0}.'/'.$tmpmd;
		if (file_exists($path.'.i'))
			unlink($path.'.i');
		if (file_exists($path.'.xhtml'))
			unlink($path.'.xhtml');
		//echo $tmpl.'<br>';
	}
	return 1;
}
?>