<?php
/**
 * Plugin Color: Sets new colors for text and background.
 * 
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Christopher Smith <chris@jalakai.co.uk>
 */
 
// must be run within Dokuwiki
if(!defined('DOKU_INC')) die();
 
if(!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
require_once(DOKU_PLUGIN.'syntax.php');
 
/**
 * All DokuWiki plugins to extend the parser/rendering mechanism
 * need to inherit from this class
 */
class syntax_plugin_swpinput extends DokuWiki_Syntax_Plugin {
 
    /**
     * return some info
     */
    function getInfo(){
        return array(
            'author' => 'Christopher Smith',
            'email'  => 'chris@jalakai.co.uk',
            'date'   => '2008-02-06',
            'name'   => 'Color Plugin',
            'desc'   => 'Changes text colour and background',
            'url'    => 'http://wiki.splitbrain.org/plugin:tutorial',
        );
    }
 
    function getType(){ return 'substition';  }
    function getAllowedTypes() { return array('formatting', 'substition', 'disabled'); }   
    function getSort(){ return 158; }
    function connectTo($mode) { $this->Lexer->addEntryPattern('<swp>.*?</swp>',$mode,'plugin_swpinput'); }
    function postConnect() { $this->Lexer->addExitPattern('</swp>','plugin_swpinput'); }
 
 
    /**
     * Handle the match
     */
    function handle($match, $state, $pos, &$handler){
        switch ($state) {
          case DOKU_LEXER_ENTER :
				return array($state,$match);
          case DOKU_LEXER_UNMATCHED :  return array($state, $match);
          case DOKU_LEXER_EXIT :       return array($state, '');
        }
        return array($match);
    }
	 
    /**
     * Create output
     */
    function render($mode, &$renderer, $data) {
		/*$ID    = getID();
		echo $ID.'<br>';
		echo 'id '.md5(wikiFN($ID).$_SERVER['HTTP_HOST'].$_SERVER['SERVER_PORT']);
		exit;*/
        if($mode == 'xhtml'){
            list($state, $match) = $data;
            switch ($state) {
			case DOKU_LEXER_ENTER :
				$renderer->doc .= '<font style="color:#f00;">'.$match.'</font>';
				require_once DOKU_PLUGIN."swpinput/swpinput.php";
				$fakt=substr($match,5,strpos($match,'(')-5);
				cache_delete($fakt);
			break;
              case DOKU_LEXER_UNMATCHED :  
				$renderer->doc .= $match; break;
			  break;
              case DOKU_LEXER_EXIT :       break;
				//break;
			}
			return true;
            }
		else
            return false;
    }
}
?>